#include <iostream>
#include <thread>
#include <chrono>
#include <amqpcpp.h>
#include "../conn_handler.h"

int main() {
    ConnHandler handler;
    // 建立连接
    AMQP::TcpConnection connection(handler,
                                   AMQP::Address("amqp-xxx.rabbitmq.ap-sh.public.tencenttdmq.com", 5672,
                                                 AMQP::Login("admin",
                                                             "eyJrZXlJZC......"),
                                                 "amqp-xxx|vhost-cpp"));
    // 建立通道
    AMQP::TcpChannel channel(&connection);
    channel.onError([&handler](const char *message) {
        std::cout << "Channel error: " << message << std::endl;
        handler.Stop();
    });

    // 声明交换机
    channel.declareExchange("my_direct_exchange", AMQP::ExchangeType::direct);
    // 队列配置
    AMQP::Table table;
    // 死信交换机
    table.set("x-dead-letter-exchange", "my_deadletter_exchange");
    // 过期时间
    table.set("x-expires", 30000);
    // 声明消息队列
    channel.declareQueue("route_queue6", AMQP::durable, table);
    // 绑定消息队列到交换机
    channel.bindQueue("my_direct_exchange", "route_queue6", "error");
    channel.bindQueue("my_direct_exchange", "route_queue6", "info");
    channel.bindQueue("my_direct_exchange", "route_queue6", "waring");
    // 订阅消息
    channel.consume("route_queue6")
            .onReceived
                    (
                            [&channel](const AMQP::Message &msg, uint64_t tag, bool redelivered) {
                                std::cout << "Received: " << msg.body() << std::endl;
//                                channel.ack(tag);
                                // 模拟消费失败进入死信
                                channel.reject(tag, 1);
                            }
                    );
    handler.Start();
    std::cout << "Closing connection." << std::endl;
    connection.close();
    return 0;
}