#include <iostream>
#include <thread>
#include <amqpcpp.h>
#include "../conn_handler.h"

int main() {
    auto evbase = event_base_new();
    LibEventHandlerMyError hndl(evbase);

    // 建立连接
    AMQP::TcpConnection connection(&hndl, AMQP::Address(
            "amqp://admin:eyJrZXlJZC......@amqp-xxx.rabbitmq.ap-sh.public.tencenttdmq.com:5672/amqp-xxx|vhost-cpp"));
    // 建立通道
    AMQP::TcpChannel channel(&connection);
    channel.onError([&evbase](const char *message) {
        std::cout << "Channel error: " << message << std::endl;
        event_base_loopbreak(evbase);
    });

    // 声明交换机
    channel.declareExchange("my_direct_exchange", AMQP::ExchangeType::direct);

    // 发送消息到交换机
    channel.publish("my_direct_exchange", "error", "Hello client this is a error message");

    event_base_dispatch(evbase);
    event_base_free(evbase);

    return 0;
}