#include <iostream>
#include <thread>
#include <chrono>
#include <amqpcpp.h>
#include "../conn_handler.h"

int main() {
    ConnHandler handler;
    // 建立连接
    AMQP::TcpConnection connection(handler,
                                   AMQP::Address("amqp-xxx.rabbitmq.ap-sh.public.tencenttdmq.com", 5672,
                                                 AMQP::Login("admin",
                                                             "eyJrZXlJZC......"),
                                                 "amqp-xxx|vhost-cpp"));
    // 建立通道
    AMQP::TcpChannel channel(&connection);
    channel.onError([&handler](const char *message) {
        std::cout << "Channel error: " << message << std::endl;
        handler.Stop();
    });

    // 声明交换机
    channel.declareExchange("ps_exchange", AMQP::ExchangeType::fanout);
    // 声明消息队列
    channel.declareQueue("ps_queue1", AMQP::durable);
    // 绑定消息队列到交换机
    channel.bindQueue("ps_exchange", "ps_queue1", "");
    channel.setQos(1);
    // 订阅消息
    channel.consume("ps_queue1")
            .onReceived
                    (
                            [&channel](const AMQP::Message &msg, uint64_t tag, bool redelivered) {
                                std::cout << "Received: " << msg.body() << std::endl;
                                channel.ack(tag);
                            }
                    );
    handler.Start();
    std::cout << "Closing connection." << std::endl;
    connection.close();
    return 0;
}