#include <iostream>
#include <thread>
#include <amqpcpp.h>
#include "../conn_handler.h"

int main() {
    auto evbase = event_base_new();
    LibEventHandlerMyError hndl(evbase);
    // 建立连接
    AMQP::TcpConnection connection(&hndl, AMQP::Address(
            "amqp://admin:eyJrZXlJZC......@amqp-xxx.rabbitmq.ap-sh.public.tencenttdmq.com:5672/amqp-xxx|vhost-cpp"));
    // 建立通道
    AMQP::TcpChannel channel(&connection);
    channel.onError([&evbase](const char *message) {
        std::cout << "Channel error: " << message << std::endl;
        event_base_loopbreak(evbase);
    });

    // 声明交换机
    channel.declareExchange("ps_exchange", AMQP::ExchangeType::fanout);
    // 发送消息到交换机
    for (int i = 0; i < 10; ++i) {
        channel.publish("ps_exchange", "", "Hello client this is a ps message");
    }

    event_base_dispatch(evbase);
    event_base_free(evbase);

    return 0;
}