#include <iostream>
#include <thread>
#include <amqpcpp.h>
#include "../conn_handler.h"

int main() {
    auto evbase = event_base_new();
    LibEventHandlerMyError hndl(evbase);

    // 建立连接
    AMQP::TcpConnection connection(&hndl, AMQP::Address(
            "amqp://admin:eyJrZXlJZC......@amqp-xxx.rabbitmq.ap-sh.public.tencenttdmq.com:5672/amqp-xxx|vhost-cpp"));
    // 建立通道
    AMQP::TcpChannel channel(&connection);
    channel.onError([&evbase](const char *message) {
        std::cout << "Channel error: " << message << std::endl;
        event_base_loopbreak(evbase);
    });

    // 声明交换机
    channel.declareExchange("topic_exchange", AMQP::ExchangeType::topic);

    // 发送消息到交换机
    channel.publish("topic_exchange", "aaa.bbb.ccc", "Hello client this is a aaa.bbb.ccc message");
    channel.publish("topic_exchange", "ccc.bbb.aaa", "Hello client this is a ccc.bbb.aaa message");
    channel.publish("topic_exchange", "aaa.aaa.aaa", "Hello client this is a aaa.aaa.aaa message");
    channel.publish("topic_exchange", "aaa.yyy.zzz", "Hello client this is a aaa.yyy.zzz message");
    channel.publish("topic_exchange", "xxx.yyy.zzz", "Hello client this is a xxx.yyy.zzz message");

    event_base_dispatch(evbase);
    event_base_free(evbase);

    return 0;
}