#include <iostream>
#include <thread>
#include <chrono>
#include <amqpcpp.h>
#include "../conn_handler.h"

int main() {
    auto evbase = event_base_new();
    LibEventHandlerMyError hndl(evbase);
    // 创建连接
    AMQP::TcpConnection connection(&hndl, AMQP::Address(
            "amqp://admin:eyJrZXlJZC......@amqp-xxx.rabbitmq.ap-sh.public.tencenttdmq.com:5672/amqp-xxx|vhost-cpp"));

    // 建立通道
    AMQP::TcpChannel channel(&connection);
    channel.onError([&evbase](const char *message) {
        std::cout << "Channel error: " << message << std::endl;
        event_base_loopbreak(evbase);
    });
    // 声明消息队列
    channel.declareQueue("task_queue", AMQP::passive)
            .onSuccess
                    (
                            [](const std::string &name,
                               uint32_t messagecount,
                               uint32_t consumercount) {
                                std::cout << "Queue: " << name << std::endl;
                            }
                    )
            .onFinalize
                    (
                            [&connection]() {
                                std::cout << "Finalize." << std::endl;
                                connection.close();
                            }
                    );
    // 发送消息到消息队列
    for (int i = 0; i < 10; ++i) {
        channel.publish("", "task_queue", "Hello client this is a work message");
    }

    event_base_dispatch(evbase);
    event_base_free(evbase);

    return 0;
}